#include "p18cxxx.inc"
;--- Pldaprogram eljeles szmok osztsra
         udata_acs          
p         res     2            ; ez a 16 bites osztand
d         res     1            ; ez a 8 bites oszt
k         res     1            ; ciklusszmll
sign      res     1            ; eljelek nyilvntartshoz
; sign<0> az osztand eljelt trolja
; sign<1> az oszt eredeti eljelt trolja
; sign<2> a hnyados eljelt trolja

RST      CODE
          goto    start
;--- Plda: p = 0x2EF0 (12016), d = 0x8D (-115)
; A hnyados = 0x98 (-104), a maradk = 0x38 (56)
PGM      CODE
start:    movlw   0xf0
          movwf   p
          movlw   0x2e
          movwf   p+1
          movlw   0x8d
          movwf   d
          call    div16_8s
          nop
          goto    $-2

;--- div16_8s: 16 bites szm osztsa 8 bitessel (mindkt szm eljeles)
;    Belpskor p az osztand, d az oszt
;    Kilpskor p als bjtja a hnyados, a fels bjt pedig a maradk 
;    Az esetleges osztsi tlcsordulst kilpskor a C=1 felttel jelzi
div16_8s: clrf    sign         ;jelzbitek trlse
          btfss   p+1,7        ;oszand eljelnek vizsglata 
          bra     tovabb       ;tlps, ha az osztand nemnegatv
          bsf     sign,2       ;belltja a hnyados eljelt
          bsf     sign,0       ;megjegyzi az osztand eljelt
          comf    p            ;p kettes komplemenst vesszk
          comf    p+1          ;(negljuk a negatv osztandt)
          incf    p            
          movlw   0
          addwfc  p+1 
tovabb:   btfss   d,7          ;oszt eljelnek vizsglata
          bra     osztas       ;tlps, ha az oszt nemnegtv
          btg     sign,2       ;ellenkezjre lltja a hnyados eljelt
          bsf     sign,1       ;megjegyzi az oszt eljelt
          negf    d            ;negljuk a negatv osztt
;--- Az eljel nlkli szmok osztsnak elvgzse --------------------
osztas:   movf    d,W          ;tlcsorduls vizsglat
          subwf   p+1,W        ;pH >= d?
          bc      kilep        ;ha C=1, akkor osztsi tlcsorduls hiba!
          movlw   8
          movwf   k            ;a ciklusszmll 8 legyen
ciklus:   movf    d,W          ;oszt elvtele
          bcf     STATUS,C
          rlcf    p
          rlcf    p+1          ;balraforgatja az osztandt
          bc      kivonas      ;ha C=1, pd > d, teht kivons kvetkezhet
          subwf   p+1          ;a parcilis osztand ellltsa kivonssal
          bc      bit_egy      ;ha C=1, pd>=d, a hnyados kvetkez bitjbe 1-et runk!
          addwf   p+1          ;ha C=0, akkor vissza kell csinlni a kivonst s t kell
          bra     szamlal      ;ugrani a hnyados kvetkez bitjnek 1-be lltsst!
kivonas:  subwf   p+1          ;a parcilis osztand ellltsa kivonssal
bit_egy:  bsf     p,0          ;a hnyados soron kvetkez bitjt '1'-be lltjuk
szamlal:  decfsz  k            ;a ciklusok visszaszmllsa
          bra     ciklus       ;jabb iterci, ha k <> 0
          bcf     STATUS,C     ;nincs tlcsorduls, Carry trlse
;---  Eljeles oszts miatti korrekcik -------------------------------
          btfsc   sign,2       ;Hnyados eljelnek vizsglata
          negf    p            ;ha sign<2>=1, akkor negljuk a hnyadost
          btfsc   sign,0       ;Osztand eredeti eljele mi volt?
          negf    p+1          ;A maradk eljelt negljuk, ha sign<0>=1  
kilep:    return
         END